
package net.mcreator.hachcksmod.fluid;

import net.minecraftforge.fluids.ForgeFlowingFluid;

import net.minecraft.world.level.material.FluidState;
import net.minecraft.world.level.material.Fluid;
import net.minecraft.world.level.block.state.StateDefinition;
import net.minecraft.world.level.block.LiquidBlock;

import net.mcreator.hachcksmod.init.HachcksModModItems;
import net.mcreator.hachcksmod.init.HachcksModModFluids;
import net.mcreator.hachcksmod.init.HachcksModModFluidTypes;
import net.mcreator.hachcksmod.init.HachcksModModBlocks;

public abstract class ValoFluid extends ForgeFlowingFluid {
	public static final ForgeFlowingFluid.Properties PROPERTIES = new ForgeFlowingFluid.Properties(() -> HachcksModModFluidTypes.VALO_TYPE.get(), () -> HachcksModModFluids.VALO.get(), () -> HachcksModModFluids.FLOWING_VALO.get())
			.explosionResistance(100f).tickRate(9095).levelDecreasePerBlock(8).slopeFindDistance(1).bucket(() -> HachcksModModItems.VALO_BUCKET.get()).block(() -> (LiquidBlock) HachcksModModBlocks.VALO.get());

	private ValoFluid() {
		super(PROPERTIES);
	}

	public static class Source extends ValoFluid {
		public int getAmount(FluidState state) {
			return 8;
		}

		public boolean isSource(FluidState state) {
			return true;
		}
	}

	public static class Flowing extends ValoFluid {
		protected void createFluidStateDefinition(StateDefinition.Builder<Fluid, FluidState> builder) {
			super.createFluidStateDefinition(builder);
			builder.add(LEVEL);
		}

		public int getAmount(FluidState state) {
			return state.getValue(LEVEL);
		}

		public boolean isSource(FluidState state) {
			return false;
		}
	}
}
